# AP4_CtrStreamCipher Class Reference

`#include <Ap4StreamCipher.h>`

Inheritance diagram for AP4_CtrStreamCipher:

List of all members.

## Public Member Functions
| AP4_CtrStreamCipher (AP4_BlockCipher *block_cipher, const AP4_UI08 *salt, AP4_Size counter_size)
| The block cipher is passed with transfer of ownership (it will be destroyed when this object is destroyed).
| ~AP4_CtrStreamCipher ()
virtual AP4_Result | SetStreamOffset (AP4_UI64 offset, AP4_Cardinal *preroll=NULL)
virtual AP4_UI64 | GetStreamOffset ()
virtual AP4_Result | ProcessBuffer (const AP4_UI08 *in, AP4_Size in_size, AP4_UI08 *out, AP4_Size *out_size=NULL, bool is_last_buffer=false)
virtual AP4_Result | SetIV (const AP4_UI08 *iv)
virtual const AP4_UI08 * | GetIV ()

## Detailed Description

Definition at line 82 of file Ap4StreamCipher.h.

## Constructor & Destructor Documentation

AP4_CtrStreamCipher::AP4_CtrStreamCipher | ( | AP4_BlockCipher * | block_cipher,
|  | const AP4_UI08 * | salt,
|  | AP4_Size | counter_size |
| ) |  |  |

The block cipher is passed with transfer of ownership (it will be destroyed when this object is destroyed).

AP4_CtrStreamCipher::~AP4_CtrStreamCipher | ( |  | ) |

## Member Function Documentation

virtual AP4_Result AP4_CtrStreamCipher::SetStreamOffset | ( | AP4_UI64 | offset,
|  | AP4_Cardinal * | preroll = `NULL` |
| ) |  |  | `[virtual]`

Implements AP4_StreamCipher.

virtual AP4_UI64 AP4_CtrStreamCipher::GetStreamOffset | ( |  | ) | `[inline, virtual]`

Implements AP4_StreamCipher.

Definition at line 99 of file Ap4StreamCipher.h.

virtual AP4_Result AP4_CtrStreamCipher::ProcessBuffer | ( | const AP4_UI08 * | in,
|  | AP4_Size | in_size,
|  | AP4_UI08 * | out,
|  | AP4_Size * | out_size = `NULL`,
|  | bool | is_last_buffer = `false` |
| ) |  |  | `[virtual]`

Implements AP4_StreamCipher.

virtual AP4_Result AP4_CtrStreamCipher::SetIV | ( | const AP4_UI08 * | iv | ) | `[virtual]`

Implements AP4_StreamCipher.

virtual const AP4_UI08* AP4_CtrStreamCipher::GetIV | ( |  | ) | `[inline, virtual]`

Implements AP4_StreamCipher.

Definition at line 107 of file Ap4StreamCipher.h.

The documentation for this class was generated from the following file:

- Ap4StreamCipher.h